import type { FindManyOptions, UpdateResult } from 'typeorm';
import type { User } from '../../../../databases/entities/User';
import { WorkflowEntity } from '../../../../databases/entities/WorkflowEntity';
import { SharedWorkflow } from '../../../../databases/entities/SharedWorkflow';
import type { Role } from '../../../../databases/entities/Role';
export declare function getSharedWorkflowIds(user: User): Promise<string[]>;
export declare function getSharedWorkflow(user: User, workflowId?: string | undefined): Promise<SharedWorkflow | null>;
export declare function getSharedWorkflows(user: User, options: {
    relations?: string[];
    workflowIds?: string[];
}): Promise<SharedWorkflow[]>;
export declare function getWorkflowById(id: string): Promise<WorkflowEntity | null>;
export declare function getWorkflowIdsViaTags(tags: string[]): Promise<string[]>;
export declare function createWorkflow(workflow: WorkflowEntity, user: User, role: Role): Promise<WorkflowEntity>;
export declare function setWorkflowAsActive(workflow: WorkflowEntity): Promise<UpdateResult>;
export declare function setWorkflowAsInactive(workflow: WorkflowEntity): Promise<UpdateResult>;
export declare function deleteWorkflow(workflow: WorkflowEntity): Promise<WorkflowEntity>;
export declare function getWorkflowsAndCount(options: FindManyOptions<WorkflowEntity>): Promise<[WorkflowEntity[], number]>;
export declare function updateWorkflow(workflowId: string, updateData: WorkflowEntity): Promise<UpdateResult>;
export declare function parseTagNames(tags: string): string[];
