import type { WebhookHttpMethod } from 'n8n-workflow';
import type express from 'express';
import { NodeTypes } from './NodeTypes';
import type { IExecutionResponse, IResponseCallbackData } from './Interfaces';
import { ExecutionRepository } from './databases/repositories';
export declare class WaitingWebhooks {
    private nodeTypes;
    private executionRepository;
    constructor(nodeTypes: NodeTypes, executionRepository: ExecutionRepository);
    executeWebhook(httpMethod: WebhookHttpMethod, fullPath: string, req: express.Request, res: express.Response): Promise<IResponseCallbackData>;
    startExecution(httpMethod: WebhookHttpMethod, path: string, fullExecutionData: IExecutionResponse, req: express.Request, res: express.Response): Promise<IResponseCallbackData>;
}
