"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LicenseInfoCommand = void 0;
const License_1 = require("../../License");
const typedi_1 = require("typedi");
const BaseCommand_1 = require("../BaseCommand");
class LicenseInfoCommand extends BaseCommand_1.BaseCommand {
    async run() {
        const license = typedi_1.Container.get(License_1.License);
        await license.init(this.instanceId);
        this.logger.info('Printing license information:\n' + license.getInfo());
    }
    async catch(error) {
        this.logger.error('\nGOT ERROR');
        this.logger.info('====================================');
        this.logger.error(error.message);
    }
}
exports.LicenseInfoCommand = LicenseInfoCommand;
LicenseInfoCommand.description = 'Print license information';
LicenseInfoCommand.examples = ['$ n8n license:info'];
//# sourceMappingURL=info.js.map