"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialsEntity = void 0;
const typeorm_1 = require("typeorm");
const class_validator_1 = require("class-validator");
const AbstractEntity_1 = require("./AbstractEntity");
const generators_1 = require("../utils/generators");
let CredentialsEntity = exports.CredentialsEntity = class CredentialsEntity extends AbstractEntity_1.AbstractEntity {
    constructor(data) {
        super();
        Object.assign(this, data);
        if (!this.id) {
            this.id = (0, generators_1.generateNanoId)();
        }
    }
    nanoId() {
        if (!this.id) {
            this.id = (0, generators_1.generateNanoId)();
        }
    }
};
__decorate([
    (0, typeorm_1.BeforeInsert)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CredentialsEntity.prototype, "nanoId", null);
__decorate([
    (0, typeorm_1.PrimaryColumn)('varchar'),
    __metadata("design:type", String)
], CredentialsEntity.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 128 }),
    (0, class_validator_1.IsString)({ message: 'Credential `name` must be of type string.' }),
    (0, class_validator_1.Length)(3, 128, {
        message: 'Credential name must be $constraint1 to $constraint2 characters long.',
    }),
    __metadata("design:type", String)
], CredentialsEntity.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)('text'),
    (0, class_validator_1.IsObject)(),
    __metadata("design:type", String)
], CredentialsEntity.prototype, "data", void 0);
__decorate([
    (0, typeorm_1.Index)(),
    (0, class_validator_1.IsString)({ message: 'Credential `type` must be of type string.' }),
    (0, typeorm_1.Column)({
        length: 128,
    }),
    __metadata("design:type", String)
], CredentialsEntity.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.OneToMany)('SharedCredentials', 'credentials'),
    __metadata("design:type", Array)
], CredentialsEntity.prototype, "shared", void 0);
__decorate([
    (0, typeorm_1.Column)(AbstractEntity_1.jsonColumnType),
    (0, class_validator_1.IsArray)(),
    __metadata("design:type", Array)
], CredentialsEntity.prototype, "nodesAccess", void 0);
exports.CredentialsEntity = CredentialsEntity = __decorate([
    (0, typeorm_1.Entity)(),
    __metadata("design:paramtypes", [Object])
], CredentialsEntity);
//# sourceMappingURL=CredentialsEntity.js.map