import { ExecutionStatus, WorkflowExecuteMode } from 'n8n-workflow';
import { Relation } from 'typeorm';
import type { ExecutionData } from './ExecutionData';
import type { ExecutionMetadata } from './ExecutionMetadata';
import { WorkflowEntity } from './WorkflowEntity';
export declare class ExecutionEntity {
    id: string;
    finished: boolean;
    mode: WorkflowExecuteMode;
    retryOf: string;
    retrySuccessId: string;
    status: ExecutionStatus;
    startedAt: Date;
    stoppedAt: Date;
    workflowId: string;
    waitTill: Date | null;
    metadata: ExecutionMetadata[];
    executionData: Relation<ExecutionData>;
    workflow: WorkflowEntity;
}
