"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddWorkflowVersionIdColumn1669739707124 = void 0;
const uuid_1 = require("uuid");
class AddWorkflowVersionIdColumn1669739707124 {
    async up({ queryRunner, tablePrefix }) {
        await queryRunner.query(`ALTER TABLE \`${tablePrefix}workflow_entity\` ADD COLUMN "versionId" char(36)`);
        const workflowIds = (await queryRunner.query(`
			SELECT id
			FROM "${tablePrefix}workflow_entity"
		`));
        for (const { id } of workflowIds) {
            const [updateQuery, updateParams] = queryRunner.connection.driver.escapeQueryWithParameters(`UPDATE "${tablePrefix}workflow_entity"
				 SET versionId = :versionId
				 WHERE id = '${id}'`, { versionId: (0, uuid_1.v4)() }, {});
            await queryRunner.query(updateQuery, updateParams);
        }
    }
    async down({ queryRunner, tablePrefix }) {
        await queryRunner.query(`ALTER TABLE \`${tablePrefix}workflow_entity\` DROP COLUMN "versionId"`);
    }
}
exports.AddWorkflowVersionIdColumn1669739707124 = AddWorkflowVersionIdColumn1669739707124;
//# sourceMappingURL=1669739707124-AddWorkflowVersionIdColumn.js.map