"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RemoveWorkflowDataLoadedFlag1671726148419 = void 0;
class RemoveWorkflowDataLoadedFlag1671726148419 {
    async up({ queryRunner, tablePrefix }) {
        const workflowIds = (await queryRunner.query(`
			SELECT id, dataLoaded
			FROM "${tablePrefix}workflow_entity"
		`));
        workflowIds.map(async ({ id, dataLoaded }) => {
            if (dataLoaded) {
                const [insertQuery, insertParams] = queryRunner.connection.driver.escapeQueryWithParameters(`
					INSERT INTO "${tablePrefix}workflow_statistics" (workflowId, name, count, latestEvent) VALUES
					(:id, :name, 1, STRFTIME('%Y-%m-%d %H:%M:%f', 'NOW'))
					`, { id, name: "data_loaded" }, {});
                return queryRunner.query(insertQuery, insertParams);
            }
            return undefined;
        });
        await queryRunner.query(`ALTER TABLE \`${tablePrefix}workflow_entity\` DROP COLUMN "dataLoaded"`);
    }
    async down({ queryRunner, tablePrefix }) {
        await queryRunner.query(`ALTER TABLE \`${tablePrefix}workflow_entity\` ADD COLUMN "dataLoaded" BOOLEAN DEFAULT false`);
        const workflowsIds = (await queryRunner.query(`
			SELECT workflowId
			FROM "${tablePrefix}workflow_statistics"
			WHERE name = '${"data_loaded"}'
		`));
        workflowsIds.map(async ({ workflowId }) => {
            return queryRunner.query(`
				UPDATE "${tablePrefix}workflow_entity"
				SET dataLoaded = true
				WHERE id = '${workflowId}'`);
        });
        await queryRunner.query(`DELETE FROM "${tablePrefix}workflow_statistics" WHERE name = '${"data_loaded"}'`);
    }
}
exports.RemoveWorkflowDataLoadedFlag1671726148419 = RemoveWorkflowDataLoadedFlag1671726148419;
//# sourceMappingURL=1671726148419-RemoveWorkflowDataLoadedFlag.js.map