import { DataSource, Repository } from 'typeorm';
import type { RoleNames, RoleScopes } from '../entities/Role';
import { Role } from '../entities/Role';
export declare class RoleRepository extends Repository<Role> {
    constructor(dataSource: DataSource);
    findGlobalOwnerRole(): Promise<Role | null>;
    findGlobalOwnerRoleOrFail(): Promise<Role>;
    findGlobalMemberRole(): Promise<Role | null>;
    findGlobalMemberRoleOrFail(): Promise<Role>;
    findWorkflowOwnerRole(): Promise<Role | null>;
    findWorkflowOwnerRoleOrFail(): Promise<Role>;
    findWorkflowEditorRoleOrFail(): Promise<Role>;
    findCredentialOwnerRole(): Promise<Role | null>;
    findCredentialOwnerRoleOrFail(): Promise<Role>;
    findCredentialUserRole(): Promise<Role | null>;
    findRole(scope: RoleScopes, name: RoleNames): Promise<Role | null>;
    findRoleOrFail(scope: RoleScopes, name: RoleNames): Promise<Role>;
}
