"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingsRepository = void 0;
const typedi_1 = require("typedi");
const typeorm_1 = require("typeorm");
const Settings_1 = require("../entities/Settings");
let SettingsRepository = exports.SettingsRepository = class SettingsRepository extends typeorm_1.Repository {
    constructor(dataSource) {
        super(Settings_1.Settings, dataSource.manager);
    }
    async saveSetting(key, value, loadOnStartup = true) {
        const setting = await this.findOneBy({ key });
        if (setting) {
            await this.update({ key }, { value, loadOnStartup });
        }
        else {
            await this.save({ key, value, loadOnStartup });
        }
    }
};
exports.SettingsRepository = SettingsRepository = __decorate([
    (0, typedi_1.Service)(),
    __metadata("design:paramtypes", [typeorm_1.DataSource])
], SettingsRepository);
//# sourceMappingURL=settings.repository.js.map