"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NoAuthRequired = exports.Authorized = void 0;
const constants_1 = require("./constants");
function Authorized(authRole = 'any') {
    return function (target, handlerName) {
        var _a;
        const controllerClass = handlerName ? target.constructor : target;
        const authRoles = ((_a = Reflect.getMetadata(constants_1.CONTROLLER_AUTH_ROLES, controllerClass)) !== null && _a !== void 0 ? _a : {});
        authRoles[handlerName !== null && handlerName !== void 0 ? handlerName : '*'] = authRole;
        Reflect.defineMetadata(constants_1.CONTROLLER_AUTH_ROLES, authRoles, controllerClass);
    };
}
exports.Authorized = Authorized;
const NoAuthRequired = () => Authorized('none');
exports.NoAuthRequired = NoAuthRequired;
//# sourceMappingURL=Authorized.js.map