"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sourceControlLicensedMiddleware = exports.sourceControlLicensedAndEnabledMiddleware = void 0;
const sourceControlHelper_ee_1 = require("../sourceControlHelper.ee");
const typedi_1 = __importDefault(require("typedi"));
const sourceControlPreferences_service_ee_1 = require("../sourceControlPreferences.service.ee");
const sourceControlLicensedAndEnabledMiddleware = (req, res, next) => {
    const sourceControlPreferencesService = typedi_1.default.get(sourceControlPreferences_service_ee_1.SourceControlPreferencesService);
    if (sourceControlPreferencesService.isSourceControlLicensedAndEnabled()) {
        next();
    }
    else {
        res.status(401).json({ status: 'error', message: 'Unauthorized' });
    }
};
exports.sourceControlLicensedAndEnabledMiddleware = sourceControlLicensedAndEnabledMiddleware;
const sourceControlLicensedMiddleware = (req, res, next) => {
    if ((0, sourceControlHelper_ee_1.isSourceControlLicensed)()) {
        next();
    }
    else {
        res.status(401).json({ status: 'error', message: 'Unauthorized' });
    }
};
exports.sourceControlLicensedMiddleware = sourceControlLicensedMiddleware;
//# sourceMappingURL=sourceControlEnabledMiddleware.ee.js.map