import { SourceControlService } from './sourceControl.service.ee';
import { SourceControlRequest } from './types/requests';
import type { SourceControlPreferences } from './types/sourceControlPreferences';
import type { PullResult, PushResult, StatusResult } from 'simple-git';
import express from 'express';
import type { ImportResult } from './types/importResult';
import { SourceControlPreferencesService } from './sourceControlPreferences.service.ee';
import type { SourceControlledFile } from './types/sourceControlledFile';
export declare class SourceControlController {
    private sourceControlService;
    private sourceControlPreferencesService;
    constructor(sourceControlService: SourceControlService, sourceControlPreferencesService: SourceControlPreferencesService);
    getPreferences(): Promise<SourceControlPreferences>;
    setPreferences(req: SourceControlRequest.UpdatePreferences): Promise<SourceControlPreferences>;
    updatePreferences(req: SourceControlRequest.UpdatePreferences): Promise<SourceControlPreferences>;
    disconnect(req: SourceControlRequest.Disconnect): Promise<SourceControlPreferences>;
    getBranches(): Promise<{
        branches: string[];
        currentBranch: string;
    }>;
    pushWorkfolder(req: SourceControlRequest.PushWorkFolder, res: express.Response): Promise<PushResult | SourceControlledFile[]>;
    pullWorkfolder(req: SourceControlRequest.PullWorkFolder, res: express.Response): Promise<SourceControlledFile[] | ImportResult | PullResult | StatusResult | undefined>;
    resetWorkfolder(req: SourceControlRequest.PullWorkFolder): Promise<ImportResult | undefined>;
    getStatus(): Promise<SourceControlledFile[]>;
    status(): Promise<StatusResult>;
    generateKeyPair(): Promise<SourceControlPreferences>;
}
