import type { IWorkflowToImport } from '../../Interfaces';
import type { ExportableCredential } from './types/exportableCredential';
import type { ExportResult } from './types/exportResult';
export declare class SourceControlExportService {
    private gitFolder;
    private workflowExportFolder;
    private credentialExportFolder;
    constructor();
    getWorkflowPath(workflowId: string): string;
    getCredentialsPath(credentialsId: string): string;
    getTagsPath(): string;
    getVariablesPath(): string;
    getWorkflowFromFile(filePath: string, root?: string): Promise<IWorkflowToImport | undefined>;
    getCredentialFromFile(filePath: string, root?: string): Promise<ExportableCredential | undefined>;
    cleanWorkFolder(): Promise<void>;
    deleteRepositoryFolder(): Promise<void>;
    private rmDeletedWorkflowsFromExportFolder;
    private writeExportableWorkflowsToExportFolder;
    exportWorkflowsToWorkFolder(): Promise<ExportResult>;
    exportVariablesToWorkFolder(): Promise<ExportResult>;
    exportTagsToWorkFolder(): Promise<ExportResult>;
    private replaceCredentialData;
    exportCredentialsToWorkFolder(): Promise<ExportResult>;
}
