"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getVariablesLimit = exports.canCreateNewVariable = exports.isVariablesEnabled = void 0;
const License_1 = require("../../License");
const typedi_1 = __importDefault(require("typedi"));
function isVariablesEnabled() {
    const license = typedi_1.default.get(License_1.License);
    return license.isVariablesEnabled();
}
exports.isVariablesEnabled = isVariablesEnabled;
function canCreateNewVariable(variableCount) {
    if (!isVariablesEnabled()) {
        return false;
    }
    const license = typedi_1.default.get(License_1.License);
    const limit = license.getVariablesLimit();
    if (limit === -1) {
        return true;
    }
    return limit > variableCount;
}
exports.canCreateNewVariable = canCreateNewVariable;
function getVariablesLimit() {
    const license = typedi_1.default.get(License_1.License);
    return license.getVariablesLimit();
}
exports.getVariablesLimit = getVariablesLimit;
//# sourceMappingURL=enviromentHelpers.js.map