"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EEVariablesController = void 0;
const express_1 = __importDefault(require("express"));
const n8n_workflow_1 = require("n8n-workflow");
const ResponseHelper = __importStar(require("../../ResponseHelper"));
const variables_service_ee_1 = require("./variables.service.ee");
const enviromentHelpers_1 = require("./enviromentHelpers");
exports.EEVariablesController = express_1.default.Router();
exports.EEVariablesController.use((req, res, next) => {
    if (!(0, enviromentHelpers_1.isVariablesEnabled)()) {
        next('router');
        return;
    }
    next();
});
exports.EEVariablesController.post('/', ResponseHelper.send(async (req) => {
    if (req.user.globalRole.name !== 'owner') {
        n8n_workflow_1.LoggerProxy.info('Attempt to update a variable blocked due to lack of permissions', {
            userId: req.user.id,
        });
        throw new ResponseHelper.AuthError('Unauthorized');
    }
    const variable = req.body;
    delete variable.id;
    try {
        return await variables_service_ee_1.EEVariablesService.create(variable);
    }
    catch (error) {
        if (error instanceof variables_service_ee_1.VariablesLicenseError) {
            throw new ResponseHelper.BadRequestError(error.message);
        }
        else if (error instanceof variables_service_ee_1.VariablesValidationError) {
            throw new ResponseHelper.BadRequestError(error.message);
        }
        throw error;
    }
}));
exports.EEVariablesController.patch('/:id(\\w+)', ResponseHelper.send(async (req) => {
    const id = req.params.id;
    if (req.user.globalRole.name !== 'owner') {
        n8n_workflow_1.LoggerProxy.info('Attempt to update a variable blocked due to lack of permissions', {
            id,
            userId: req.user.id,
        });
        throw new ResponseHelper.AuthError('Unauthorized');
    }
    const variable = req.body;
    delete variable.id;
    try {
        return await variables_service_ee_1.EEVariablesService.update(id, variable);
    }
    catch (error) {
        if (error instanceof variables_service_ee_1.VariablesLicenseError) {
            throw new ResponseHelper.BadRequestError(error.message);
        }
        else if (error instanceof variables_service_ee_1.VariablesValidationError) {
            throw new ResponseHelper.BadRequestError(error.message);
        }
        throw error;
    }
}));
//# sourceMappingURL=variables.controller.ee.js.map