import type { IPushDataType } from '../Interfaces';
export declare abstract class AbstractPush<T> {
    protected connections: Record<string, T>;
    protected abstract close(connection: T): void;
    protected abstract sendToOne(connection: T, data: string): void;
    protected add(sessionId: string, connection: T): void;
    protected remove(sessionId?: string): void;
    send<D>(type: IPushDataType, data: D, sessionId: string | undefined): void;
}
