import type { EntityManager, FindOptionsWhere } from 'typeorm';
import { User } from '../databases/entities/User';
import type { IUserSettings } from 'n8n-workflow';
export declare class UserService {
    static get(where: FindOptionsWhere<User>): Promise<User | null>;
    static getByIds(transaction: EntityManager, ids: string[]): Promise<User[]>;
    static updateUserSettings(id: string, userSettings: Partial<IUserSettings>): Promise<import("typeorm").UpdateResult>;
    static generatePasswordResetUrl(user: User): Promise<string>;
}
