export declare const xsdSamlSchemaMetadata20 = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<schema\n    targetNamespace=\"urn:oasis:names:tc:SAML:2.0:metadata\"\n    xmlns:md=\"urn:oasis:names:tc:SAML:2.0:metadata\"\n    xmlns:ds=\"http://www.w3.org/2000/09/xmldsig#\"\n    xmlns:xenc=\"http://www.w3.org/2001/04/xmlenc#\"\n    xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\"\n    xmlns=\"http://www.w3.org/2001/XMLSchema\"\n    elementFormDefault=\"unqualified\"\n    attributeFormDefault=\"unqualified\"\n    blockDefault=\"substitution\"\n    version=\"2.0\">\n    <import namespace=\"http://www.w3.org/2000/09/xmldsig#\"\n        schemaLocation=\"xmldsig-core-schema.xsd\"/>\n    <import namespace=\"http://www.w3.org/2001/04/xmlenc#\"\n        schemaLocation=\"xenc-schema.xsd\"/>\n    <import namespace=\"urn:oasis:names:tc:SAML:2.0:assertion\"\n        schemaLocation=\"saml-schema-assertion-2.0.xsd\"/>\n    <import namespace=\"http://www.w3.org/XML/1998/namespace\"\n        schemaLocation=\"xml.xsd\"/>\n    <annotation>\n        <documentation>\n            Document identifier: saml-schema-metadata-2.0\n            Location: http://docs.oasis-open.org/security/saml/v2.0/\n            Revision history:\n              V2.0 (March, 2005):\n                Schema for SAML metadata, first published in SAML 2.0.\n        </documentation>\n    </annotation>\n\n    <simpleType name=\"entityIDType\">\n        <restriction base=\"anyURI\">\n            <maxLength value=\"1024\"/>\n        </restriction>\n    </simpleType>\n    <complexType name=\"localizedNameType\">\n        <simpleContent>\n            <extension base=\"string\">\n                <attribute ref=\"xml:lang\" use=\"required\"/>\n            </extension>\n        </simpleContent>\n    </complexType>\n    <complexType name=\"localizedURIType\">\n        <simpleContent>\n            <extension base=\"anyURI\">\n                <attribute ref=\"xml:lang\" use=\"required\"/>\n            </extension>\n        </simpleContent>\n    </complexType>\n    \n    <element name=\"Extensions\" type=\"md:ExtensionsType\"/>\n    <complexType final=\"#all\" name=\"ExtensionsType\">\n        <sequence>\n            <any namespace=\"##other\" processContents=\"lax\" maxOccurs=\"unbounded\"/>\n        </sequence>\n    </complexType>\n    \n    <complexType name=\"EndpointType\">\n        <sequence>\n            <any namespace=\"##other\" processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <attribute name=\"Binding\" type=\"anyURI\" use=\"required\"/>\n        <attribute name=\"Location\" type=\"anyURI\" use=\"required\"/>\n        <attribute name=\"ResponseLocation\" type=\"anyURI\" use=\"optional\"/>\n        <anyAttribute namespace=\"##other\" processContents=\"lax\"/>\n    </complexType>\n    \n    <complexType name=\"IndexedEndpointType\">\n        <complexContent>\n            <extension base=\"md:EndpointType\">\n                <attribute name=\"index\" type=\"unsignedShort\" use=\"required\"/>\n                <attribute name=\"isDefault\" type=\"boolean\" use=\"optional\"/>\n            </extension>\n        </complexContent>\n    </complexType>\n    \n    <element name=\"EntitiesDescriptor\" type=\"md:EntitiesDescriptorType\"/>\n    <complexType name=\"EntitiesDescriptorType\">\n        <sequence>\n            <element ref=\"ds:Signature\" minOccurs=\"0\"/>\n            <element ref=\"md:Extensions\" minOccurs=\"0\"/>\n            <choice minOccurs=\"1\" maxOccurs=\"unbounded\">\n                <element ref=\"md:EntityDescriptor\"/>\n                <element ref=\"md:EntitiesDescriptor\"/>\n            </choice>\n        </sequence>\n        <attribute name=\"validUntil\" type=\"dateTime\" use=\"optional\"/>\n        <attribute name=\"cacheDuration\" type=\"duration\" use=\"optional\"/>\n        <attribute name=\"ID\" type=\"ID\" use=\"optional\"/>\n        <attribute name=\"Name\" type=\"string\" use=\"optional\"/>\n    </complexType>\n\n    <element name=\"EntityDescriptor\" type=\"md:EntityDescriptorType\"/>\n    <complexType name=\"EntityDescriptorType\">\n        <sequence>\n            <element ref=\"ds:Signature\" minOccurs=\"0\"/>\n            <element ref=\"md:Extensions\" minOccurs=\"0\"/>\n            <choice>\n                <choice maxOccurs=\"unbounded\">\n                    <element ref=\"md:RoleDescriptor\"/>\n                    <element ref=\"md:IDPSSODescriptor\"/>\n                    <element ref=\"md:SPSSODescriptor\"/>\n                    <element ref=\"md:AuthnAuthorityDescriptor\"/>\n                    <element ref=\"md:AttributeAuthorityDescriptor\"/>\n                    <element ref=\"md:PDPDescriptor\"/>\n                </choice>\n                <element ref=\"md:AffiliationDescriptor\"/>\n            </choice>\n            <element ref=\"md:Organization\" minOccurs=\"0\"/>\n            <element ref=\"md:ContactPerson\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n            <element ref=\"md:AdditionalMetadataLocation\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <attribute name=\"entityID\" type=\"md:entityIDType\" use=\"required\"/>\n        <attribute name=\"validUntil\" type=\"dateTime\" use=\"optional\"/>\n        <attribute name=\"cacheDuration\" type=\"duration\" use=\"optional\"/>\n        <attribute name=\"ID\" type=\"ID\" use=\"optional\"/>\n        <anyAttribute namespace=\"##other\" processContents=\"lax\"/>\n    </complexType>\n    \n    <element name=\"Organization\" type=\"md:OrganizationType\"/>\n    <complexType name=\"OrganizationType\">\n        <sequence>\n            <element ref=\"md:Extensions\" minOccurs=\"0\"/>\n            <element ref=\"md:OrganizationName\" maxOccurs=\"unbounded\"/>\n            <element ref=\"md:OrganizationDisplayName\" maxOccurs=\"unbounded\"/>\n            <element ref=\"md:OrganizationURL\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <anyAttribute namespace=\"##other\" processContents=\"lax\"/>\n    </complexType>\n    <element name=\"OrganizationName\" type=\"md:localizedNameType\"/>\n    <element name=\"OrganizationDisplayName\" type=\"md:localizedNameType\"/>\n    <element name=\"OrganizationURL\" type=\"md:localizedURIType\"/>\n    <element name=\"ContactPerson\" type=\"md:ContactType\"/>\n    <complexType name=\"ContactType\">\n        <sequence>\n            <element ref=\"md:Extensions\" minOccurs=\"0\"/>\n            <element ref=\"md:Company\" minOccurs=\"0\"/>\n            <element ref=\"md:GivenName\" minOccurs=\"0\"/>\n            <element ref=\"md:SurName\" minOccurs=\"0\"/>\n            <element ref=\"md:EmailAddress\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n            <element ref=\"md:TelephoneNumber\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <attribute name=\"contactType\" type=\"md:ContactTypeType\" use=\"required\"/>\n        <anyAttribute namespace=\"##other\" processContents=\"lax\"/>\n    </complexType>\n    <element name=\"Company\" type=\"string\"/>\n    <element name=\"GivenName\" type=\"string\"/>\n    <element name=\"SurName\" type=\"string\"/>\n    <element name=\"EmailAddress\" type=\"anyURI\"/>\n    <element name=\"TelephoneNumber\" type=\"string\"/>\n    <simpleType name=\"ContactTypeType\">\n        <restriction base=\"string\">\n            <enumeration value=\"technical\"/>\n            <enumeration value=\"support\"/>\n            <enumeration value=\"administrative\"/>\n            <enumeration value=\"billing\"/>\n            <enumeration value=\"other\"/>\n        </restriction>\n    </simpleType>\n\n    <element name=\"AdditionalMetadataLocation\" type=\"md:AdditionalMetadataLocationType\"/>\n    <complexType name=\"AdditionalMetadataLocationType\">\n        <simpleContent>\n            <extension base=\"anyURI\">\n                <attribute name=\"namespace\" type=\"anyURI\" use=\"required\"/>\n            </extension>\n        </simpleContent>\n    </complexType>\n\n    <element name=\"RoleDescriptor\" type=\"md:RoleDescriptorType\"/>\n    <complexType name=\"RoleDescriptorType\" abstract=\"true\">\n        <sequence>\n            <element ref=\"ds:Signature\" minOccurs=\"0\"/>\n            <element ref=\"md:Extensions\" minOccurs=\"0\"/>\n            <element ref=\"md:KeyDescriptor\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n            <element ref=\"md:Organization\" minOccurs=\"0\"/>\n            <element ref=\"md:ContactPerson\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <attribute name=\"ID\" type=\"ID\" use=\"optional\"/>\n        <attribute name=\"validUntil\" type=\"dateTime\" use=\"optional\"/>\n        <attribute name=\"cacheDuration\" type=\"duration\" use=\"optional\"/>\n        <attribute name=\"protocolSupportEnumeration\" type=\"md:anyURIListType\" use=\"required\"/>\n        <attribute name=\"errorURL\" type=\"anyURI\" use=\"optional\"/>\n        <anyAttribute namespace=\"##other\" processContents=\"lax\"/>\n    </complexType>\n    <simpleType name=\"anyURIListType\">\n        <list itemType=\"anyURI\"/>\n    </simpleType>\n\n    <element name=\"KeyDescriptor\" type=\"md:KeyDescriptorType\"/>\n    <complexType name=\"KeyDescriptorType\">\n        <sequence>\n            <element ref=\"ds:KeyInfo\"/>\n            <element ref=\"md:EncryptionMethod\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <attribute name=\"use\" type=\"md:KeyTypes\" use=\"optional\"/>\n    </complexType>\n    <simpleType name=\"KeyTypes\">\n        <restriction base=\"string\">\n            <enumeration value=\"encryption\"/>\n            <enumeration value=\"signing\"/>\n        </restriction>\n    </simpleType>\n    <element name=\"EncryptionMethod\" type=\"xenc:EncryptionMethodType\"/>\n    \n    <complexType name=\"SSODescriptorType\" abstract=\"true\">\n        <complexContent>\n            <extension base=\"md:RoleDescriptorType\">\n                <sequence>\n                    <element ref=\"md:ArtifactResolutionService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:SingleLogoutService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:ManageNameIDService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:NameIDFormat\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                </sequence>\n            </extension>\n        </complexContent>\n    </complexType>\n    <element name=\"ArtifactResolutionService\" type=\"md:IndexedEndpointType\"/>\n    <element name=\"SingleLogoutService\" type=\"md:EndpointType\"/>\n    <element name=\"ManageNameIDService\" type=\"md:EndpointType\"/>\n    <element name=\"NameIDFormat\" type=\"anyURI\"/>\n\n    <element name=\"IDPSSODescriptor\" type=\"md:IDPSSODescriptorType\"/>\n    <complexType name=\"IDPSSODescriptorType\">\n        <complexContent>\n            <extension base=\"md:SSODescriptorType\">\n                <sequence>\n                    <element ref=\"md:SingleSignOnService\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:NameIDMappingService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:AssertionIDRequestService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:AttributeProfile\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"saml:Attribute\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                </sequence>\n                <attribute name=\"WantAuthnRequestsSigned\" type=\"boolean\" use=\"optional\"/>\n            </extension>\n        </complexContent>\n    </complexType>\n    <element name=\"SingleSignOnService\" type=\"md:EndpointType\"/>\n    <element name=\"NameIDMappingService\" type=\"md:EndpointType\"/>\n    <element name=\"AssertionIDRequestService\" type=\"md:EndpointType\"/>\n    <element name=\"AttributeProfile\" type=\"anyURI\"/>\n    \n    <element name=\"SPSSODescriptor\" type=\"md:SPSSODescriptorType\"/>\n    <complexType name=\"SPSSODescriptorType\">\n        <complexContent>\n            <extension base=\"md:SSODescriptorType\">\n                <sequence>\n                    <element ref=\"md:AssertionConsumerService\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:AttributeConsumingService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                </sequence>\n                <attribute name=\"AuthnRequestsSigned\" type=\"boolean\" use=\"optional\"/>\n                <attribute name=\"WantAssertionsSigned\" type=\"boolean\" use=\"optional\"/>\n            </extension>\n        </complexContent>\n    </complexType>\n    <element name=\"AssertionConsumerService\" type=\"md:IndexedEndpointType\"/>\n    <element name=\"AttributeConsumingService\" type=\"md:AttributeConsumingServiceType\"/>\n    <complexType name=\"AttributeConsumingServiceType\">\n        <sequence>\n            <element ref=\"md:ServiceName\" maxOccurs=\"unbounded\"/>\n            <element ref=\"md:ServiceDescription\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n            <element ref=\"md:RequestedAttribute\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <attribute name=\"index\" type=\"unsignedShort\" use=\"required\"/>\n        <attribute name=\"isDefault\" type=\"boolean\" use=\"optional\"/>\n    </complexType>\n    <element name=\"ServiceName\" type=\"md:localizedNameType\"/>\n    <element name=\"ServiceDescription\" type=\"md:localizedNameType\"/>\n    <element name=\"RequestedAttribute\" type=\"md:RequestedAttributeType\"/>\n    <complexType name=\"RequestedAttributeType\">\n        <complexContent>\n            <extension base=\"saml:AttributeType\">\n                <attribute name=\"isRequired\" type=\"boolean\" use=\"optional\"/>\n            </extension>\n        </complexContent>\n    </complexType>\n  \n    <element name=\"AuthnAuthorityDescriptor\" type=\"md:AuthnAuthorityDescriptorType\"/>\n    <complexType name=\"AuthnAuthorityDescriptorType\">\n        <complexContent>\n            <extension base=\"md:RoleDescriptorType\">\n                <sequence>\n                    <element ref=\"md:AuthnQueryService\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:AssertionIDRequestService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:NameIDFormat\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                </sequence>\n            </extension>\n        </complexContent>\n    </complexType>\n    <element name=\"AuthnQueryService\" type=\"md:EndpointType\"/>\n\n    <element name=\"PDPDescriptor\" type=\"md:PDPDescriptorType\"/>\n    <complexType name=\"PDPDescriptorType\">\n        <complexContent>\n            <extension base=\"md:RoleDescriptorType\">\n                <sequence>\n                    <element ref=\"md:AuthzService\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:AssertionIDRequestService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:NameIDFormat\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                </sequence>\n            </extension>\n        </complexContent>\n    </complexType>\n    <element name=\"AuthzService\" type=\"md:EndpointType\"/>\n\n    <element name=\"AttributeAuthorityDescriptor\" type=\"md:AttributeAuthorityDescriptorType\"/>\n    <complexType name=\"AttributeAuthorityDescriptorType\">\n        <complexContent>\n            <extension base=\"md:RoleDescriptorType\">\n                <sequence>\n                    <element ref=\"md:AttributeService\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:AssertionIDRequestService\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:NameIDFormat\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"md:AttributeProfile\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                    <element ref=\"saml:Attribute\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n                </sequence>\n            </extension>\n        </complexContent>\n    </complexType>\n    <element name=\"AttributeService\" type=\"md:EndpointType\"/>\n   \n    <element name=\"AffiliationDescriptor\" type=\"md:AffiliationDescriptorType\"/>\n    <complexType name=\"AffiliationDescriptorType\">\n        <sequence>\n            <element ref=\"ds:Signature\" minOccurs=\"0\"/>\n            <element ref=\"md:Extensions\" minOccurs=\"0\"/>\n            <element ref=\"md:AffiliateMember\" maxOccurs=\"unbounded\"/>\n        </sequence>\n        <attribute name=\"affiliationOwnerID\" type=\"md:entityIDType\" use=\"required\"/>\n        <attribute name=\"validUntil\" type=\"dateTime\" use=\"optional\"/>\n        <attribute name=\"cacheDuration\" type=\"duration\" use=\"optional\"/>\n        <attribute name=\"ID\" type=\"ID\" use=\"optional\"/>\n        <anyAttribute namespace=\"##other\" processContents=\"lax\"/>\n    </complexType>\n    <element name=\"AffiliateMember\" type=\"md:entityIDType\"/>\n</schema>";
